package datasets;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

import renderer.Loader;
import utilities.MNMatrix;

public class DataFileReader {

	public static Dataset loadDataset(String fileName, Loader loader) {
		
		FileReader fr = null;
		try {
			fr = new FileReader(new File("res/"+fileName+".txt"));
		} catch (FileNotFoundException e) {
			System.err.println("Could not load file!");
			e.printStackTrace();
		}
		BufferedReader reader = new BufferedReader(fr);
		String line;
		
		try{
			line = reader.readLine();
			String[] currentLine = line.split(",");
			int r = Integer.parseInt(currentLine[0]);
			int c = Integer.parseInt(currentLine[1]);
			MNMatrix matrix = new MNMatrix(r,c);
			matrix.fillEmptyMatrix();
			line = reader.readLine();
			int currentRow = 0;
			while(line != null) {
				currentLine = line.split(",");
				for (int i = 0; i < c; i++) {
					matrix.setValue(currentRow, i, Float.parseFloat(currentLine[i]));
				}
				currentRow++;
				line = reader.readLine();
			}
			reader.close();
			
			return new Dataset(matrix,loader);
		}catch(Exception e ) {
			e.printStackTrace();
		}
		return null;
	}
}
