package display;


import org.lwjgl.opengl.ContextAttribs;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.LWJGLException;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.PixelFormat;


public class DisplayRenderer {
    
    private static final int WIDTH = 1280;
    private static final int HEIGHT = 720; // HD, 16:9 aspect ratio
    private static final int FPS = 60;
    
    public static void initialize() {
        
        ContextAttribs attribs = new ContextAttribs(3,2)    // Version of OpenGL.
                                .withForwardCompatible(true)
                                .withProfileCore(true); 
        
        try {
            Display.setDisplayMode(new DisplayMode(WIDTH, HEIGHT));
            Display.create(new PixelFormat().withDepthBits(24), attribs);
            Display.setTitle("Graphics");
        } catch (LWJGLException e) {
            e.printStackTrace();
        }
        
        GL11.glViewport(0, 0, WIDTH, HEIGHT); // Where in the display can the game be rendered, we choose whole display ie. top/bottom/left/right are arguments.
    }
    
    public static void update() {
        Display.sync(FPS); //synchronize the game to run at a steady FPS
        Display.update();
    }
    
    public static void close() {
        Display.destroy();
    }
}