package renderer;

import java.util.List;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL20;
import org.lwjgl.opengl.GL30;
import org.lwjgl.util.vector.Matrix4f;
import org.lwjgl.util.vector.Vector3f;

import assets.Grid;
import models.Model;
import shaderPrograms.Shader;
import utilities.Utils;

public class GridRenderer {

	private Shader shader;
	 
    public GridRenderer(Shader shader, Matrix4f projectionMatrix) {
        this.shader = shader;
        shader.start();
        shader.loadProjectionMatrix(projectionMatrix);
        shader.stop();
        
    }
    
    public void render(Grid cube) {
    	return;
    	/**** This is how the grid would be rendered ****
    	for (int i = -2; i < 3; i++) {
    		for (int j = -2; j < 3; j++) {
    			for (int k = -2; k < 3; k++) {
		            prepareCube(cube);
		            Vector3f trans = new Vector3f(i,j,k);
		            loadModelMatrix(cube, trans);
		            GL11.glDrawElements(GL11.GL_LINES, cube.getModel().getVertexCount(),
		                    GL11.GL_UNSIGNED_INT, 0);
		            GL20.glDisableVertexAttribArray(0);
		            GL20.glDisableVertexAttribArray(1);
		            //GL20.glDisableVertexAttribArray(2);
		            GL30.glBindVertexArray(0);
    			}
    		}
    	}*/
    }
 
    private void prepareCube(Grid cube) {
        Model model = cube.getModel();
        GL30.glBindVertexArray(model.getVaoID());
        GL20.glEnableVertexAttribArray(0);
        GL20.glEnableVertexAttribArray(1);
    }
    
    private void loadModelMatrix(Grid cube, Vector3f trans) {
        Matrix4f modelMatrix = Utils.createModelMatrix(
                trans, 0, 0, 0, 1);
        shader.loadModelMatrix(modelMatrix);
    }
}
