package shaderPrograms;

import org.lwjgl.util.vector.Matrix4f;

import assets.ViewControl;
//import assets.Light;
import utilities.Utils;


public class Shader extends SuperShader{

	private static final String VERTEX_SHADER_FILE = "src/shaderPrograms/vertexShader.txt";
	private static final String FRAGMENT_SHADER_FILE = "src/shaderPrograms/fragmentShader.txt";
	
	private int location_projectionMatrix;
	private int location_viewMatrix;
	private int location_modelMatrix;
	
	public Shader() {
		super(VERTEX_SHADER_FILE, FRAGMENT_SHADER_FILE);
	}
  
	 @Override
	protected void getAllUniformLocations() {
	        location_projectionMatrix = super.getUniformLocation("projectionMatrix");
	        location_viewMatrix = super.getUniformLocation("viewMatrix");
	        location_modelMatrix = super.getUniformLocation("modelMatrix");
	} 

	 public void loadProjectionMatrix(Matrix4f matrix){
	        super.loadMatrix(location_projectionMatrix, matrix);
	 }
	 
	 public void loadViewMatrix(ViewControl camera){
		 	Matrix4f matrix = Utils.createViewMatrix(camera);
	        super.loadMatrix(location_viewMatrix, matrix);
	 }

	 public void loadModelMatrix(Matrix4f matrix) {
		 	super.loadMatrix(location_modelMatrix, matrix);
	 }
}
